/*
 *  MICO --- an Open Source CORBA implementation
 *  Copyright (c) 1997-2001 by The Mico Team
 *
 *  This file was automatically generated. DO NOT EDIT!
 */

#include <CORBA.h>
#include <mico/throw.h>

#ifndef __AS_STUB_H__
#define __AS_STUB_H__


class Account;
typedef Account *Account_ptr;
typedef Account_ptr AccountRef;
typedef ObjVar< Account > Account_var;
typedef ObjOut< Account > Account_out;

class Asdatabase;
typedef Asdatabase *Asdatabase_ptr;
typedef Asdatabase_ptr AsdatabaseRef;
typedef ObjVar< Asdatabase > Asdatabase_var;
typedef ObjOut< Asdatabase > Asdatabase_out;



struct Astuple;
typedef TVarVar< Astuple > Astuple_var;
typedef TVarOut< Astuple > Astuple_out;


struct Astuple {
  #ifdef HAVE_TYPEDEF_OVERLOAD
  typedef Astuple_var _var_type;
  #endif
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  Astuple();
  ~Astuple();
  Astuple( const Astuple& s );
  Astuple& operator=( const Astuple& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS

  CORBA::ULong nDate;
  CORBA::ULong nTime;
  CORBA::String_var szName;
  CORBA::String_var szTask;
  CORBA::String_var szRemark;
};


/*
 * Base class and common definitions for interface Account
 */

class Account : 
  virtual public CORBA::Object
{
  public:
    virtual ~Account();

    #ifdef HAVE_TYPEDEF_OVERLOAD
    typedef Account_ptr _ptr_type;
    typedef Account_var _var_type;
    #endif

    static Account_ptr _narrow( CORBA::Object_ptr obj );
    static Account_ptr _narrow( CORBA::AbstractBase_ptr obj );
    static Account_ptr _duplicate( Account_ptr _obj )
    {
      CORBA::Object::_duplicate (_obj);
      return _obj;
    }

    static Account_ptr _nil()
    {
      return 0;
    }

    virtual void *_narrow_helper( const char *repoid );

    virtual void Log( const ::Astuple& Msgline ) = 0;
    virtual char* Dump() = 0;

  protected:
    Account() {};
  private:
    Account( const Account& );
    void operator=( const Account& );
};

// Stub for interface Account
class Account_stub:
  virtual public Account
{
  public:
    virtual ~Account_stub();
    void Log( const ::Astuple& Msgline );
    char* Dump();

  private:
    void operator=( const Account_stub& );
};

#ifndef MICO_CONF_NO_POA

class Account_stub_clp :
  virtual public Account_stub,
  virtual public PortableServer::StubBase
{
  public:
    Account_stub_clp (PortableServer::POA_ptr, CORBA::Object_ptr);
    virtual ~Account_stub_clp ();
    void Log( const ::Astuple& Msgline );
    char* Dump();

  protected:
    Account_stub_clp ();
  private:
    void operator=( const Account_stub_clp & );
};

#endif // MICO_CONF_NO_POA


/*
 * Base class and common definitions for interface Asdatabase
 */

class Asdatabase : 
  virtual public CORBA::Object
{
  public:
    virtual ~Asdatabase();

    #ifdef HAVE_TYPEDEF_OVERLOAD
    typedef Asdatabase_ptr _ptr_type;
    typedef Asdatabase_var _var_type;
    #endif

    static Asdatabase_ptr _narrow( CORBA::Object_ptr obj );
    static Asdatabase_ptr _narrow( CORBA::AbstractBase_ptr obj );
    static Asdatabase_ptr _duplicate( Asdatabase_ptr _obj )
    {
      CORBA::Object::_duplicate (_obj);
      return _obj;
    }

    static Asdatabase_ptr _nil()
    {
      return 0;
    }

    virtual void *_narrow_helper( const char *repoid );

    virtual ::Account_ptr Open( const char* Filename ) = 0;

  protected:
    Asdatabase() {};
  private:
    Asdatabase( const Asdatabase& );
    void operator=( const Asdatabase& );
};

// Stub for interface Asdatabase
class Asdatabase_stub:
  virtual public Asdatabase
{
  public:
    virtual ~Asdatabase_stub();
    ::Account_ptr Open( const char* Filename );

  private:
    void operator=( const Asdatabase_stub& );
};

#ifndef MICO_CONF_NO_POA

class Asdatabase_stub_clp :
  virtual public Asdatabase_stub,
  virtual public PortableServer::StubBase
{
  public:
    Asdatabase_stub_clp (PortableServer::POA_ptr, CORBA::Object_ptr);
    virtual ~Asdatabase_stub_clp ();
    ::Account_ptr Open( const char* Filename );

  protected:
    Asdatabase_stub_clp ();
  private:
    void operator=( const Asdatabase_stub_clp & );
};

#endif // MICO_CONF_NO_POA

#ifndef MICO_CONF_NO_POA

class POA_Account : virtual public PortableServer::StaticImplementation
{
  public:
    virtual ~POA_Account ();
    Account_ptr _this ();
    bool dispatch (CORBA::StaticServerRequest_ptr);
    virtual void invoke (CORBA::StaticServerRequest_ptr);
    virtual CORBA::Boolean _is_a (const char *);
    virtual CORBA::InterfaceDef_ptr _get_interface ();
    virtual CORBA::RepositoryId _primary_interface (const PortableServer::ObjectId &, PortableServer::POA_ptr);

    virtual void * _narrow_helper (const char *);
    static POA_Account * _narrow (PortableServer::Servant);
    virtual CORBA::Object_ptr _make_stub (PortableServer::POA_ptr, CORBA::Object_ptr);

    virtual void Log( const ::Astuple& Msgline ) = 0;
    virtual char* Dump() = 0;

  protected:
    POA_Account () {};

  private:
    POA_Account (const POA_Account &);
    void operator= (const POA_Account &);
};

class POA_Asdatabase : virtual public PortableServer::StaticImplementation
{
  public:
    virtual ~POA_Asdatabase ();
    Asdatabase_ptr _this ();
    bool dispatch (CORBA::StaticServerRequest_ptr);
    virtual void invoke (CORBA::StaticServerRequest_ptr);
    virtual CORBA::Boolean _is_a (const char *);
    virtual CORBA::InterfaceDef_ptr _get_interface ();
    virtual CORBA::RepositoryId _primary_interface (const PortableServer::ObjectId &, PortableServer::POA_ptr);

    virtual void * _narrow_helper (const char *);
    static POA_Asdatabase * _narrow (PortableServer::Servant);
    virtual CORBA::Object_ptr _make_stub (PortableServer::POA_ptr, CORBA::Object_ptr);

    virtual ::Account_ptr Open( const char* Filename ) = 0;

  protected:
    POA_Asdatabase () {};

  private:
    POA_Asdatabase (const POA_Asdatabase &);
    void operator= (const POA_Asdatabase &);
};

#endif // MICO_CONF_NO_POA

extern CORBA::StaticTypeInfo *_marshaller_Astuple;

extern CORBA::StaticTypeInfo *_marshaller_Account;

extern CORBA::StaticTypeInfo *_marshaller_Asdatabase;

#endif
